| OpenNI 2.0

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Members

Public Member Functions | Friends
openni::PlaybackControl Class Reference

`#include <OpenNI.h>`

List of all members.

## Public Member Functions

| ~PlaybackControl ()
int | getNumberOfFrames (const VideoStream &stream) const
bool | getRepeatEnabled () const
float | getSpeed () const
bool | isValid () const
Status | seek (const VideoStream &stream, int frameIndex)
Status | setRepeatEnabled (bool repeat)
Status | setSpeed (float speed)

## Friends

class | Device

## Detailed Description

The PlaybackControl class provides access to a series of specific to playing back a recording from a file device.

When playing a stream back from a recording instead of playing from a live device, it is possible to vary playback speed, change the current time location (ie fast forward / rewind / seek), specify whether the playback should be repeated at the end of the recording, and query the total size of the recording.

Since none of these functions make sense in the context of a physical device, they are split out into a seperate playback control class. To use, simply create your file device, create a PlaybackControl, and then attach the PlaybackControl to the file device.

## Constructor & Destructor Documentation

openni::PlaybackControl::~PlaybackControl | ( |  | ) | `[inline]`

Deconstructor. Destroys a PlaybackControl class. The deconstructor presently detaches from its recording automatically, but it is considered a best practice for applications to manually detach from any stream that was attached to.

## Member Function Documentation

int openni::PlaybackControl::getNumberOfFrames | ( | const VideoStream & | stream | ) | const`[inline]`

Provides the a count of frames that this recording contains for a given stream. This is useful both to determine the length of the recording, and to ensure that a valid Frame Index is set when using the PlaybackControl::seek() function.

Parameters:

  [in] | stream | The video stream to count frames for

Returns:
  Number of frames in provided VideoStream, or 0 if the stream is not part of the recording

bool openni::PlaybackControl::getRepeatEnabled | ( |  | ) | const`[inline]`

Gets the current repeat setting of the file device.

Returns:
  true if repeat is enabled, false if not enabled.

float openni::PlaybackControl::getSpeed | ( |  | ) | const`[inline]`

Getter function for the current playback speed of this device.

This value is expressed as a multiple of the speed the original recording was taken at. For example, if the original recording was at 30fps, and playback speed is set to 0.5, then the recording will play at 15fps. If playback speed is set to 2.0, then the recording would playback at 60fps.

In addition, there are two "special" values. A playback speed of 0.0 indicates that the playback should occur as fast as the system is capable of returning frames. This is most useful when testing algorithms on large datasets, as it enables playback to be done at a much higher rate than would otherwise be possible.

A value of -1 indicates that speed is "manual". In this mode, new frames will only become available when an application manually reads them. If used in a polling loop, this setting also enables systems to read and process frames limited only by available processing speeds.

Returns:
  Current playback speed of the device, measured as ratio of recording speed.

bool openni::PlaybackControl::isValid | ( |  | ) | const`[inline]`

Status openni::PlaybackControl::seek | ( | const VideoStream & | stream,
|  | int | frameIndex
| ) |  | `[inline]`

Seeks within a VideoStream to a given FrameID. Note that when this function is called on one stream, all other streams will also be changed to the corresponding place in the recording. The FrameIDs of different streams may not match, since FrameIDs may differ for streams that are not synchronized, but the recording will set all streams to the same moment in time.

Parameters:

  [in] | stream | Stream for which the frameIndex value is valid.
  [in] | frameIndex | Frame index to move playback to

Returns:
  Status code indicating success or failure of this operation

Status openni::PlaybackControl::setRepeatEnabled | ( | bool | repeat | ) | `[inline]`

Changes the current repeat mode of the device. If repeat mode is turned on, then the recording will begin playback again at the beginning after the last frame is read. If turned off, no more frames will become available after last frame is read.

Parameters:

  [in] | repeat | New value for repeat -- true to enable, false to disable

Returns:
  Status code indicating success or failure of this operations.

Status openni::PlaybackControl::setSpeed | ( | float | speed | ) | `[inline]`

Setter function for the playback speed of the device. For a full explaination of what this value means

See also:
  PlaybackControl::getSpeed().

Parameters:

  [in] | speed | Desired new value of playback speed, as ratio of original recording.

Returns:
  Status code indicating success or failure of this operation.

## Friends And Related Function Documentation

friend class Device `[friend]`

The documentation for this class was generated from the following file:

- OpenNI.h